MODULE DosSupport;

IMPORT
  d := Dos,
  e := Exec,
  Y := SYSTEM;

(* Print out a dos.library error-message *)
PROCEDURE PrintFault * ;
BEGIN
  Y.SETREG(0,d.PrintFault(d.IoErr(),NIL));
END PrintFault;

(* Print out dos.library error-message "Not enough free store" *)
PROCEDURE PrintMemErr * ;
BEGIN
  Y.SETREG(0,d.PrintFault(d.noFreeStore,NIL));
END PrintMemErr;


(* Check if Ctrl-C was pressed *)
PROCEDURE CheckCtrlC* ():BOOLEAN;
BEGIN
  IF d.ctrlC IN d.CheckSignal(LONGSET{d.ctrlC}) THEN
    d.PrintF("*** Break ***\n");
    RETURN TRUE;
  ELSE
    RETURN FALSE;
  END
END CheckCtrlC;


BEGIN
  IF d.base.lib.version < 36 THEN HALT(20); END;
END DosSupport.
